--- media/audio/BUILD.gn.orig	2024-09-30 07:45:04 UTC
+++ media/audio/BUILD.gn
@@ -268,9 +268,23 @@ source_set("audio") {
     deps += [ "//media/base/android:media_jni_headers" ]
   }
 
-  if (is_linux || is_chromeos) {
+  if ((is_linux || is_chromeos) && !is_bsd) {
     sources += [ "linux/audio_manager_linux.cc" ]
   }
+
+  if (is_bsd) {
+    sources += [ "sndio/audio_manager_sndio.cc" ]
+  }
+
+  if (use_sndio) {
+    libs += [ "sndio" ]
+    sources += [
+      "sndio/sndio_input.cc",
+      "sndio/sndio_input.h",
+      "sndio/sndio_output.cc",
+      "sndio/sndio_output.h"
+    ]
+   }
 
   if (use_alsa) {
     libs += [ "asound" ]
